//----------------------------------------------------------------------------
// umTimer.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: umTimer.pas
//----------------------------------------------------------------------------
#ifndef umTimerHPP
#define umTimerHPP
//----------------------------------------------------------------------------
#include <umClasses.hpp>
#include <Classes.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Umtimer
{
//-- type declarations -------------------------------------------------------
typedef Set<Shortint, 0, 59>  TumCronSet;

enum TumCronGroups { crSec, crMin, crHour, crDay, crMonth, crDoW };

class __declspec(delphiclass) TumCron;
class __declspec(pascalimplementation) TumCron : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	TumCronSet Groups[6];
	
public:
	void __fastcall Init( System::ShortString &CronMask);
	bool __fastcall IsCron(const _SYSTEMTIME &CheckTime);
public:
	/* TObject.Create */ __fastcall TumCron(void) : System::TObject() { }
	/* TObject.Destroy */ __fastcall virtual ~TumCron(void) { }
	
};

class __declspec(delphiclass) TumCustomTimer;
class __declspec(pascalimplementation) TumCustomTimer : public Umclasses::TumHandleComponent
{
	typedef Umclasses::TumHandleComponent inherited;
	
private:
	bool FActive;
	Cardinal FAlertsCount;
	
protected:
	virtual void __fastcall WndProc(Messages::TMessage &Message);
	void __fastcall Tick(void);
	virtual void __fastcall DoTimer(void);
	
public:
	__fastcall virtual TumCustomTimer(Classes::TComponent* aOwner);
	__fastcall virtual ~TumCustomTimer(void);
	virtual void __fastcall Reset(void);
	__property bool Active = {read=FActive, write=FActive, default=1};
	__property Cardinal AlertsCount = {read=FAlertsCount, nodefault};
};

class __declspec(delphiclass) TumCustomAccurateTimer;
class __declspec(pascalimplementation) TumCustomAccurateTimer : public TumCustomTimer
{
	typedef TumCustomTimer inherited;
	
private:
	Cardinal FCurrent;
	Classes::TNotifyEvent FOnTimer;
	
protected:
	Cardinal FInterval;
	virtual void __fastcall DoTimer(void);
	void __fastcall Update(Cardinal Increment);
	
public:
	__fastcall virtual TumCustomAccurateTimer(Classes::TComponent* aOwner);
	virtual void __fastcall Reset(void);
	__property Cardinal Interval = {read=FInterval, write=FInterval, default=1000};
	__property Classes::TNotifyEvent OnTimer = {read=FOnTimer, write=FOnTimer};
public:
	/* TumCustomTimer.Destroy */ __fastcall virtual ~TumCustomAccurateTimer(void) { }
	
};

class __declspec(delphiclass) TumAccurateTimer;
class __declspec(pascalimplementation) TumAccurateTimer : public TumCustomAccurateTimer
{
	typedef TumCustomAccurateTimer inherited;
	
__published:
	__property Active ;
	__property Interval ;
	__property OnTimer ;
public:
	/* TumCustomAccurateTimer.Create */ __fastcall virtual TumAccurateTimer(Classes::TComponent* aOwner
		) : Umtimer::TumCustomAccurateTimer(aOwner) { }
	
public:
	/* TumCustomTimer.Destroy */ __fastcall virtual ~TumAccurateTimer(void) { }
	
};

class __declspec(delphiclass) TumCronJob;
class __declspec(pascalimplementation) TumCronJob : public TumCustomTimer
{
	typedef TumCustomTimer inherited;
	
private:
	System::AnsiString FCronMask;
	Classes::TNotifyEvent FOnAlert;
	TumCron* FCron;
	_SYSTEMTIME FLastCronTime;
	void __fastcall SetCronMask(const System::AnsiString Value);
	System::TDateTime __fastcall GetLastTime(void);
	
protected:
	virtual void __fastcall DoTimer(void);
	void __fastcall Update(const _SYSTEMTIME &CheckTime);
	
public:
	__fastcall virtual TumCronJob(Classes::TComponent* aOwner);
	__fastcall virtual ~TumCronJob(void);
	__property _SYSTEMTIME LastCronTime = {read=FLastCronTime};
	__property System::TDateTime LastTime = {read=GetLastTime};
	
__published:
	__property Active ;
	__property System::AnsiString CronMask = {read=FCronMask, write=SetCronMask, nodefault};
	__property Classes::TNotifyEvent OnAlert = {read=FOnAlert, write=FOnAlert};
};

//-- var, const, procedure ---------------------------------------------------
extern void __fastcall finalization(void);
//-- template instantiations -------------------------------------------------
template class TumCronSet ;

}	/* namespace Umtimer */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Umtimer;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// umTimer
